      function PwdAbsorption(tth)
      include 'fepc.cmn'
      include 'basic.cmn'
      include 'datred.cmn'
      include 'powder.cmn'
      dimension AbsVal(19,81),aa(7,19),yy(2)
      data ((absval(i,j),i=1,19),j=1,49)/
     1 1.00,1.00,1.00,1.00,1.00,1.00,1.00,1.00,1.00,1.00,
     2 1.00,1.00,1.00,1.00,1.00,1.00,1.00,1.00,1.00,
     3 1.18,1.18,1.18,1.18,1.18,1.18,1.18,1.18,1.18,1.18,
     4 1.18,1.18,1.18,1.18,1.18,1.18,1.18,1.18,1.18,
     5 1.40,1.40,1.40,1.40,1.40,1.40,1.39,1.39,1.39,1.39,
     6 1.39,1.38,1.38,1.38,1.38,1.38,1.37,1.37,1.37,
     7 1.65,1.65,1.65,1.65,1.65,1.64,1.64,1.63,1.63,1.62,
     8 1.62,1.61,1.61,1.60,1.59,1.59,1.59,1.59,1.59,
     9 1.95,1.95,1.95,1.94,1.94,1.93,1.92,1.91,1.90,1.89,
     a 1.87,1.86,1.85,1.84,1.83,1.82,1.82,1.81,1.81,
     1 2.29,2.29,2.29,2.28,2.27,2.26,2.24,2.22,2.20,2.18,
     2 2.16,2.13,2.12,2.10,2.08,2.07,2.06,2.05,2.05,
     3 2.69,2.69,2.69,2.67,2.65,2.63,2.60,2.57,2.53,2.50,
     4 2.47,2.43,2.40,2.37,2.35,2.33,2.31,2.30,2.30,
     5 3.16,3.16,3.15,3.13,3.09,3.05,3.01,2.96,2.91,2.85,
     6 2.80,2.75,2.71,2.66,2.63,2.60,2.58,2.56,2.56,
     7 3.70,3.70,3.68,3.65,3.60,3.54,3.47,3.39,3.32,3.24,
     8 3.16,3.09,3.03,2.97,2.92,2.88,2.85,2.84,2.83,
     9 4.33,4.33,4.30,4.24,4.17,4.08,3.98,3.87,3.76,3.65,
     a 3.55,3.46,3.37,3.29,3.23,3.18,3.14,3.11,3.11,
     1 5.06,5.05,5.01,4.92,4.81,4.68,4.54,4.39,4.24,4.10,
     2 3.97,3.84,3.73,3.63,3.55,3.48,3.43,3.40,3.39,
     3 5.90,5.88,5.81,5.69,5.54,5.36,5.16,4.96,4.76,4.58,
     4 4.40,4.24,4.10,3.97,3.87,3.79,3.73,3.69,3.68,
     5 6.86,6.84,6.74,6.57,6.35,6.10,5.84,5.57,5.32,5.08,
     6 4.86,4.66,4.49,4.33,4.20,4.11,4.03,3.98,3.97,
     7 7.96,7.93,7.79,7.55,7.25,6.92,6.58,6.23,5.91,5.61,
     8 5.34,5.09,4.88,4.70,4.54,4.43,4.34,4.28,4.27,
     9 9.23,9.18,8.97,8.65,8.25,7.82,7.37,6.94,6.53,6.16,
     a 5.83,5.54,5.29,5.07,4.89,4.75,4.65,4.58,4.57,
     1 10.7,10.6,10.3,9.88,9.35,8.79,8.22,7.68,7.19,6.74,
     2 6.35,6.00,5.71,5.45,5.24,5.08,4.96,4.89,4.87,
     3 12.3,12.2,11.8,11.2,10.6,9.84,9.13,8.47,7.87,7.34,
     4 6.87,6.47,6.13,5.84,5.60,5.42,5.28,5.19,5.17,
     5 14.2,14.0,13.5,12.7,11.9,11.0,10.1,9.30,8.58,7.96,
     6 7.42,6.95,6.57,6.23,5.96,5.75,5.60,5.50,5.48,
     7 16.3,16.0,15.4,14.4,13.3,12.2,11.1,10.2,9.32,8.59,
     8 7.97,7.45,7.01,6.63,6.33,6.09,5.92,5.81,5.78,
     9 18.6,18.3,17.5,16.2,14.8,13.5,12.2,11.1,10.1,9.25,
     a 8.54,7.94,7.45,7.03,6.69,6.44,6.24,6.12,6.09,
     1 21.3,20.9,19.8,18.2,16.5,14.8,13.3,12.0,10.9,9.91,
     2 9.12,8.45,7.91,7.44,7.06,6.78,6.56,6.43,6.40,
     3 24.2,23.7,22.3,20.3,18.2,16.2,14.5,12.9,11.7,10.6,
     4 9.71,8.97,8.36,7.84,7.44,7.13,6.89,6.75,6.71,
     5 27.5,26.9,25.1,22.6,20.1,17.7,15.7,13.9,12.5,11.3,
     6 10.3,9.49,8.82,8.26,7.81,7.47,7.22,7.06,7.02,
     7 31.2,30.4,28.1,25.1,22.0,19.3,16.9,14.9,13.3,12.0,
     8 10.9,10.0,9.29,8.67,8.19,7.82,7.54,7.38,7.33,
     9 35.3,34.2,31.4,27.7,24.1,20.9,18.2,16.0,14.2,12.7,
     a 11.5,10.5,9.76,9.09,8.57,8.17,7.87,7.69,7.64,
     1 39.8,38.5,34.9,30.5,26.2,22.5,19.5,17.0,15.0,13.4,
     2 12.1,11.1,10.2,9.51,8.95,8.53,8.20,8.01,7.96,
     3 44.7,43.1,38.7,33.4,28.5,24.2,20.8,18.1,15.9,14.2,
     4 12.8,11.6,10.7,9.93,9.33,8.88,8.53,8.33,8.27,
     5 50.1,48.1,42.8,36.5,30.8,26.0,22.2,19.2,16.8,14.9,
     6 13.4,12.2,11.2,10.4,9.72,9.23,8.87,8.64,8.58,
     7 56.1,53.5,47.2,39.7,33.2,27.8,23.6,20.3,17.7,15.6,
     8 14.0,12.7,11.7,10.8,10.1,9.59,9.20,8.96,8.90,
     9 62.5,59.4,51.8,43.1,35.7,29.6,25.0,21.4,18.6,16.4,
     a 14.6,13.2,12.1,11.2,10.5,9.95,9.53,9.28,9.21,
     1 69.5,65.8,56.7,46.6,38.2,31.5,26.4,22.5,19.5,17.1,
     2 15.3,13.8,12.6,11.6,10.9,10.3,9.86,9.60,9.53,
     3 77.2,72.6,61.8,50.3,40.8,33.4,27.9,23.7,20.4,17.9,
     4 15.9,14.3,13.1,12.1,11.3,10.7,10.2,9.92,9.84,
     5 85.4,79.9,67.3,54.0,43.5,35.4,29.3,24.8,21.4,18.7,
     6 16.6,14.9,13.6,12.5,11.7,11.0,10.5,10.2,10.2,
     7 94.2,87.6,72.9,57.9,46.2,37.3,30.8,26.0,22.3,19.4,
     8 17.2,15.5,14.1,12.9,12.0,11.4,10.9,10.6,10.5,
     9 104.,95.9,78.9,61.9,48.9,39.3,32.3,27.1,23.2,20.2,
     a 17.9,16.0,14.6,13.4,12.4,11.7,11.2,10.9,10.8,
     1 114.,105.,85.0,65.9,51.7,41.3,33.8,28.3,24.2,21.0,
     2 18.5,16.6,15.1,13.8,12.8,12.1,11.5,11.2,11.1,
     3 125.,114.,91.4,70.1,54.6,43.3,35.5,29.5,25.1,21.7,
     4 19.2,17.1,15.6,14.2,13.2,12.5,11.9,11.5,11.4,
     5 136.,124.,98.0,74.4,57.4,45.4,36.9,30.7,26.1,22.5,
     6 19.8,17.7,16.1,14.7,13.6,12.8,12.2,11.8,11.7,
     7 149.,134.,105.,78.7,60.4,47.5,38.4,31.9,27.0,23.3,
     8 20.5,18.3,16.6,15.1,14.0,13.2,12.6,12.2,12.1,
     9 162.,145.,112.,83.1,63.3,49.5,39.9,33.1,28.0,24.1,
     a 21.2,18.8,17.1,15.6,14.4,13.6,12.9,12.5,12.4,
     1 175.,156.,119.,87.6,66.3,51.6,41.5,34.3,28.9,24.9,
     2 21.8,19.4,17.6,16.0,14.8,13.9,13.2,12.8,12.7,
     3 190.,168.,127.,92.1,69.3,53.8,43.1,35.5,29.9,25.7,
     4 22.5,20.0,18.1,16.4,15.2,14.3,13.6,13.1,13.0,
     5 206.,180.,134.,96.7,72.3,55.9,44.6,36.7,30.9,26.5,
     6 23.2,20.6,18.6,16.9,15.6,14.6,13.9,13.5,13.3,
     7 222.,193.,142.,101.,75.4,58.0,46.2,37.9,31.8,27.3,
     8 23.8,21.1,19.1,17.3,16.0,15.0,14.3,13.8,13.7,
     9 239.,206.,150.,106.,78.5,60.2,47.8,39.1,32.8,28.1,
     a 24.5,21.7,19.6,17.8,16.4,15.4,14.6,14.1,14.0,
     1 257.,220.,158.,111.,81.6,62.3,49.4,40.4,33.8,28.9,
     2 25.2,22.3,20.1,18.2,16.8,15.7,14.9,14.4,14.3,
     3 275.,234.,166.,116.,84.7,64.5,51.0,41.6,34.8,29.7,
     4 25.8,22.9,20.6,18.7,17.2,16.1,15.3,14.8,14.6,
     5 295.,249.,175.,121.,87.8,66.7,52.6,42.8,35.8,30.5,
     6 26.5,23.4,21.1,19.1,17.6,16.5,15.6,15.1,14.9,
     7 316.,264.,183.,125.,91.0,68.9,54.2,44.1,36.7,31.3,
     8 27.2,24.0,21.6,19.6,18.0,16.9,16.0,15.4,15.3/
      data ((absval(i,j),i=1,19),j=50,81)/
     9 337.,280.,192.,130.,94.2,71.1,55.8,45.3,37.7,32.1,
     a 27.9,24.6,22.1,20.0,18.4,17.2,16.3,15.7,15.6,
     1 359.,296.,200.,135.,97.4,73.3,57.5,46.6,38.7,32.9,
     2 28.6,25.2,22.6,20.5,18.8,17.6,16.7,16.1,15.9,
     3 383.,313.,209.,140.,101.,75.5,59.1,47.8,39.7,33.7,
     4 29.2,25.8,23.1,20.9,19.2,18.0,17.0,16.4,16.2,
     5 407.,330.,218.,145.,104.,77.8,60.7,49.1,40.7,34.5,
     6 29.9,26.3,23.6,21.4,19.6,18.3,17.3,16.7,16.6,
     7 432.,348.,228.,150.,107.,80.0,62.4,50.3,41.7,35.3,
     8 30.6,26.9,24.1,21.8,20.0,18.7,17.7,17.1,16.9,
     9 458.,366.,237.,156.,110.,82.3,64.0,51.6,42.7,36.1,
     a 31.3,27.5,24.6,22.3,20.4,19.1,18.0,17.4,17.2,
     1 485.,384.,246.,161.,114.,84.5,65.7,52.9,43.7,37.0,
     2 32.0,28.1,25.2,22.7,20.9,19.5,18.4,17.7,17.5,
     3 513.,403.,255.,166.,117.,86.8,67.3,54.1,44.7,37.8,
     4 32.7,28.7,25.7,23.2,21.3,19.8,18.7,18.0,17.9,
     5 542.,422.,265.,171.,120.,89.1,69.0,55.4,45.7,38.6,
     6 33.4,29.3,26.2,23.6,21.7,20.2,19.1,18.4,18.2,
     7 573.,442.,275.,176.,124.,91.4,70.7,56.7,46.8,39.4,
     8 34.0,29.9,26.7,24.1,22.1,20.6,19.4,18.7,18.5,
     9 604.,462.,284.,182.,127.,93.6,72.4,58.0,47.8,40.3,
     a 34.7,30.5,27.2,24.5,22.5,21.0,19.8,19.0,18.8,
     1 636.,483.,294.,187.,130.,95.9,74.0,59.2,48.8,41.1,
     2 35.4,31.0,27.7,25.0,22.9,21.3,20.1,19.4,19.2,
     3 670.,504.,304.,192.,134.,98.3,75.7,60.5,49.8,41.9,
     4 36.1,31.6,28.3,25.4,23.3,21.7,20.5,19.7,19.5,
     5 704.,525.,314.,198.,137.,101.,77.4,61.8,50.8,42.7,
     6 36.8,32.2,28.8,25.9,23.7,22.1,20.8,20.0,19.8,
     7 740.,547.,324.,203.,140.,103.,79.1,63.1,51.9,43.6,
     8 37.5,32.8,29.3,26.4,24.1,22.5,21.2,20.4,20.25,
     9 777.,569.,334.,209.,144.,105.,80.8,64.4,52.5,44.4,
     a 38.2,33.3,29.8,26.8,24.6,22.8,21.5,20.7,20.5,
     1 814.,591.,345.,214.,147.,108.,82.5,65.7,53.9,45.2,
     2 38.9,34.0,30.3,27.3,25.0,23.2,21.9,21.0,20.8,
     3 853.,614.,355.,219.,151.,110.,84.2,67.0,54.9,46.1,
     4 39.6,34.6,30.9,27.7,25.4,23.6,22.2,21.4,21.1,
     5 894.,638.,365.,225.,154.,112.,85.9,68.3,56.0,46.9,
     6 40.3,35.2,31.4,28.2,25.8,24.0,22.6,21.7,21.5,
     7 935.,661.,376.,231.,158.,115.,87.6,69.6,57.0,47.8,
     8 41.0,35.8,31.9,28.7,26.2,24.4,23.0,22.1,21.8,
     9 978.,685.,386.,236.,161.,117.,89.4,70.9,58.0,48.6,
     a 41.7,36.4,32.4,29.1,26.6,24.8,23.3,22.4,22.1,
     11022.,710.,397.,242.,165.,119.,91.1,72.2,59.1,49.4,
     2 42.4,37.0,33.0,29.6,27.0,25.1,23.7,22.7,22.5,
     31067.,735.,408.,247.,168.,122.,92.8,73.6,60.1,50.3,
     4 43.1,37.6,33.5,30.1,27.5,25.5,24.0,23.1,22.8,
     51113.,760.,418.,253.,172.,124.,94.6,74.9,61.2,51.1,
     6 43.8,38.2,34.0,30.5,27.9,25.9,24.4,23.4,23.1,
     71161.,785.,429.,259.,175.,127.,96.3,76.2,62.2,52.0,
     8 44.6,38.8,34.6,31.0,28.3,26.3,24.7,23.8,23.5,
     91210.,811.,440.,264.,179.,129.,98.1,77.5,63.3,52.8,
     a 45.3,39.5,35.1,31.5,28.7,26.7,25.1,24.1,23.8,
     11260.,837.,451.,270.,182.,131.,99.8,78.9,64.3,53.7,
     2 46.0,40.1,35.6,31.9,29.2,27.1,25.5,24.4,24.1,
     31311.,864.,462.,276.,186.,134.,102.,80.2,65.4,54.5,
     4 46.7,40.7,36.1,32.4,29.6,27.4,25.8,24.8,24.5,
     51364.,891.,473.,281.,190.,136.,103.,81.5,66.4,55.4,
     6 47.4,41.3,36.7,32.9,30.0,27.8,26.2,25.1,24.8,
     71418.,918.,484.,287.,193.,139.,105.,82.9,67.5,56.2,
     8 48.1,41.9,37.2,33.3,30.4,28.2,26.5,25.5,25.2,
     91474.,945.,495.,293.,197.,141.,107.,84.2,68.5,57.1,
     a 48.9,42.5,37.8,33.8,30.8,28.6,26.9,25.8,25.5,
     11530.,974.,507.,299.,200.,144.,109.,85.5,69.6,58.0,
     2 49.5,43.1,38.3,34.3,31.3,29.0,27.3,26.1,25.8/
      data aa
     1  /0.000000,0.000000, 0.318300, 0.000000, 0.955000,0.000000,7.1,
     2   0.001615,0.031400, 0.064800, 0.835000, 0.140000,0.000000,0.0,
     3   0.006420,0.053000, 0.179000, 0.057000, 0.000000,0.000000,0.0,
     4   0.014420,0.086000, 0.061000, 0.330000, 0.000000,0.000000,0.0,
     5   0.025400,0.105000, 0.080000, 0.130000, 0.000000,0.000000,0.0,
     6   0.039400,0.123000, 0.073000,-0.160000, 0.000000,0.000000,0.0,
     7   0.056000,0.139000, 0.000000, 0.000000, 0.000000,0.000000,0.0,
     8   0.075200,0.150000,-0.022000, 0.000000, 0.000000,0.000000,0.0,
     9   0.096600,0.159000,-0.100000, 0.000000, 0.000000,0.000000,0.0,
     a   0.119900,0.164000,-0.160000, 0.000000, 0.000000,0.000000,0.0,
     1   0.144800,0.160000,-0.200000, 0.000000, 0.000000,0.000000,0.0,
     2   0.174100,0.130000,-0.300000, 0.000000, 0.000000,0.000000,0.0,
     3   0.198400,0.110000,-0.210000, 0.000000, 0.000000,0.000000,0.0,
     4   0.226000,0.100000,-0.330000, 0.000000, 0.000000,0.000000,0.0,
     5   0.250000,0.105000,-0.480000, 0.000000, 0.000000,0.000000,0.0,
     6   0.274000,0.080000,-0.520000, 0.000000, 0.000000,0.000000,0.0,
     7   0.295000,0.064000,-0.640000, 0.000000, 0.000000,0.000000,0.0,
     8   0.310700,0.030000,-0.500000, 0.000000, 0.000000,0.000000,0.0,
     9   0.318300,0.000000,-0.530000, 0.000000, 0.000000,0.000000,0.0/
      if(Kabsor(KDatBlock).le.IdPwdAbsorbNone.or.
     1   MirPwd(KDatBlock).le.0.) then
        PwdAbsorption=1.
      else if(Kabsor(KDatBlock).eq.IdPwdAbsorbCylinder) then
        th=.5*tth/torad
        d1=.1*tth/torad+1.
        j=d1
        d1=d1-float(j)
        d2=MirPwd(KDatBlock)*10.+1.
        i=d2
        d2=d2-float(i)
        if(i.lt.81) then
          PwdAbsorption=absval(j,i)+d1*(absval(j+1,i)-absval(j,i))+
     1                              d2*(absval(j,i+1)-absval(j,i))+
     2                           d1*d2*(absval(j+1,i+1)+absval(j,i)-
     3                                  absval(j+1,i)-absval(j,i+1))
        else
          xm=1.
          xd=1./MirPwd(KDatBlock)
          call SetRealArrayTo(yy,2,0.)
          do l=1,7
            xm=xm*xd
            m=0
            do k=j,j+1
              m=m+1
              yy(m)=yy(m)+aa(l,k)*xm
            enddo
          enddo
          do k=1,2
            if(yy(k).gt.0.) then
              yy(k)=1./yy(k)
            else
              yy(k)=999999.
            endif
          enddo
          PwdAbsorption=yy(1)+d1*(yy(2)-yy(1))
        endif
      else if(Kabsor(KDatBlock).eq.IdPwdAbsorbTransmission) then
        sec=1./cos(tth*.5)
        PwdAbsorption=1./ExpJana(-MirPwd(KDatBlock)*sec,ich)
      else if(Kabsor(KDatBlock).eq.IdPwdAbsorbReflection) then
        cosec=1./sin(tth*.5)
        PwdAbsorption=cosec/
     1                (1.-ExpJana(-2.*MirPwd(KDatBlock)*cosec,ich))
      endif
      return
      end
